package com.yonyou.occ.codegenerator;

import java.util.ArrayList;
import java.util.List;

public class Table {
	private final String name;

	private final String code;

	private final String comment;

	private final String className;

	private final String requestMapping;

	private final String referenceType;

	private List<Column> columns = new ArrayList<Column>();

	public Table(String name, String code, String comment, String referenceType) {
		this.name = name;
		this.code = code;
		this.comment = comment;

		className = GeneratorHelper.getClassName(code);
		requestMapping = GeneratorHelper.getRequestMapping(code);
		this.referenceType = referenceType;
	}

	public String getName() {
		return name;
	}

	public String getCode() {
		return code;
	}

	public String getComment() {
		return comment;
	}

	public String getClassName() {
		return className;
	}

	public String getRequestMapping() {
		return requestMapping;
	}

	public String getReferenceType() {
		return referenceType;
	}

	public List<Column> getColumns() {
		return columns;
	}

	public void setColumns(List<Column> columns) {
		this.columns = columns;
	}

	public class Column {
		/**
		 * 名称
		 */
		private final String name;

		/**
		 * 编码
		 */
		private final String code;

		/**
		 * 注释
		 */
		private final String comment;

		/**
		 * 数据类型
		 */
		private final String dataType;

		/**
		 * 长度
		 */
		private final Integer length;

		/**
		 * 精度
		 */
		private final Integer precision;

		/**
		 * 字段名
		 */
		private final String fieldName;

		/**
		 * 属性名
		 */
		private final String propertyName;

		/**
		 * 字段类型
		 */
		private final String fieldType;

		public Column(String name, String code, String comment, String dataType, Integer length, Integer precision) {
			this.name = name;
			this.code = code;
			this.comment = comment;
			this.dataType = dataType;
			this.length = length;
			this.precision = precision;

			fieldName = GeneratorHelper.getFieldName(code);
			propertyName = GeneratorHelper.getPropertyName(code);
			fieldType = GeneratorHelper.getFieldType(dataType);
		}

		public String getName() {
			return name;
		}

		public String getCode() {
			return code;
		}

		public String getComment() {
			return comment;
		}

		public String getDataType() {
			return dataType;
		}

		public Integer getLength() {
			return length;
		}

		public Integer getPrecision() {
			return precision;
		}

		public String getFieldName() {
			return fieldName;
		}

		public String getPropertyName() {
			return propertyName;
		}

		public String getFieldType() {
			return fieldType;
		}
	}
}
